import checkers.quals.*;

class Extensions {

    class BaseClass {
        String mutableReceiver() {return null;}
        String readonlyReceiver() @ReadOnly {return null;}
        @Mutable String mutableReturn() {return null;}
        @RoMaybe String roMaybeReturn() @RoMaybe {return null;}
        @ReadOnly String readonlyReturn() {return null;}
    }

    @ReadOnly class ReadOnlyExtension extends BaseClass {}

    @Mutable class MutableExtension extends BaseClass {}

    @RoMaybe class RoMaybeIllegalExtension extends BaseClass {}

    class SwitchReceivers extends BaseClass {
        String mutableReceiver() @ReadOnly {return null;}
        String readonlyReceiver() @Mutable {return null;} // error
    }

    class SwitchReturns extends BaseClass {
        @ReadOnly String mutableReturn() {return null;} // error
        @Mutable String readonlyReturn() {return null;}
    }

    class RoMaybeReturns extends BaseClass {
        @RoMaybe String mutableReturn() {return null;} // error
        @RoMaybe String readonlyReturn() {return null;}
    }

    class ForceRoMaybeReturnToMutable extends BaseClass {
        @Mutable String roMaybeReturn() @RoMaybe {return null;}
    }

    class ForceRoMaybeReturnToReadOnly extends BaseClass {
        @ReadOnly String roMaybeReturn() @RoMaybe {return null;} // error
    }

    class RoMaybeReceivers extends BaseClass {
        String mutableReceiver() @RoMaybe {return null;}
        String readonlyReceiver() @RoMaybe {return null;} // error
    }

}
