import checkers.quals.*;

class RoMaybes {

    @Mutable @Assignable String mString;
    String tmString;
    @ReadOnly String roString;

    RoMaybes (@RoMaybe String s) @RoMaybe {
        mString = s;           // error, cannot assign to mutable
        tmString = s;          // assignable at constructor
        roString = s;          // assignable at constructor

        @RoMaybe String a = s; // ok
        @RoMaybe String b = a; // ok

        a = mString;           // ok
        a = tmString;          // ok
        a = roString;          // error

        mString = a;           // error
        tmString = a;          // ok
        roString = a;          // ok
    }

    @RoMaybe String testAsMutableReceiver(@RoMaybe String s) {
        mString = s;           // error, cannot assign to mutable
        tmString = s;          // error, cannot assign to mutable
        roString = s;          // ok

        @RoMaybe String a = s; // ok
        @RoMaybe String b = a; // ok

        a = mString;           // ok
        a = tmString;          // ok
        a = roString;          // error

        mString = a;           // error
        tmString = a;          // error
        roString = a;          // ok

        return null;
    }

    @RoMaybe String testAsReadOnlyReceiver(@RoMaybe String s) @ReadOnly {
        mString = s;           // error, s might be readonly
        tmString = s;          // error, local field
        roString = s;          // error, local field

        @RoMaybe String a = s; // ok
        @RoMaybe String b = a; // ok

        a = mString;           // ok
        a = tmString;          // error, a might be mutable
        a = roString;          // error, a might be mutable

        mString = a;           // error, a might be readonly
        tmString = a;          // error, local field
        roString = a;          // error, local field

        return null;
    }

    @RoMaybe String testAsRoMaybeReceiver(@RoMaybe String s) @RoMaybe {
        mString = s;           // error, s might be readonly
        tmString = s;          // error, local field
        roString = s;          // error, local field

        @RoMaybe String a = s; // ok
        @RoMaybe String b = a; // ok

        a = mString;           // ok
        a = tmString;          // ok
        a = roString;          // error, a might be mutable

        mString = a;           // error, a might be readonly
        tmString = a;          // error, local field
        roString = a;          // error, local field

        return null;
    }



}
