import checkers.quals.*;

public class Flow {

    public void testIf() {
        
        String str = "foo";
        @NonNull String a;
        if (str != null) {
           a = str; 
        }

        str = null;
        @NonNull String b = str;
    }
    
    public void testIfNoBlock() {

        String str = "foo";
        @NonNull String a;
        if (str != null)
            a = str;

        str = null;
        @NonNull String b = str;
    }

    public void testElse() {

        String str = "foo";
        @NonNull String a;
        if (str == null) {
            testAssert();
        } else {
            a = str;
        }

        str = null;
        @NonNull String b = str;
    }

    public void testElseNoBlock() {

        String str = "foo";
        @NonNull String a;
        if (str == null)
            testAssert();
        else
            a = str;

        str = null;
        @NonNull String b = str;
    }

    public void testReturnIf() {

        String str = "foo";
        if (str == null) {
            testAssert();
            return;
        }

        @NonNull String a = str;
        
        str = null;
        @NonNull String b = str;
    }

    public void testReturnElse() {

        String str = "foo";
        if (str != null) {
            testAssert();
        } else
            return;

        @NonNull String a = str;

        str = null;
        @NonNull String b = str;
    }

    public void testThrowIf() {

        String str = "foo";
        if (str == null) {
            testAssert();
            throw new RuntimeException("foo");
        }

        @NonNull String a = str;

        str = null;
        @NonNull String b = str;
    }

    public void testThrowElse() {

        String str = "foo";
        if (str != null) {
            testAssert();
        } else
            throw new RuntimeException("foo");

        @NonNull String a = str;

        str = null;
        @NonNull String b = str;
    }

    public void testAssert() {

        String str = "foo";
        assert str != null;

        @NonNull String a = str;

        str = null;
        @NonNull String b = str;
    }

    public void testWhile() {

        String str = "foo";
        while (str != null) {
            @NonNull String a = str; 
            break;
        }

        str = null;
        @NonNull String b = str;
    }

    public void testIfInstanceOf() {

        String str = "foo";
        @NonNull String a;
        if (str instanceof String) {
           a = str; 
        }

        str = null;
        @NonNull String b = str;
    }

    public void testNew() {
        
        String str = "foo";
        @NonNull String a = str;
       
        str = null;
        @NonNull String b = str;
    }

    public void testExit() {

        String str = null;
        if (str == null) {
            System.exit(0);
        }

        @NonNull String a = str;
    }
}
